#!/usr/bin/perl
use strict;

# Traverses one directory and converts all icon files .svg in it.
# Calls itself recursively for all directorys in that directory.
# Avoids symlinks (This is very important, to avoid that icons are modified twice!)
# Arg 1: path
sub process_dir
{
    my $dir = shift;
    for my $file (glob $dir . "/*") {
        if (-l $file) {
            next;
        } elsif (-d -r -x $file) {
            &process_dir($file);
        } elsif (-f -r $file) {
            &process_icon($file);
        } else {
            die "Can not work with path $file";
        }
    }
}

# Calls change-to-dark on the breeze icon, to make it breeze-dark icon.
# Arg 1: path
sub process_icon
{
    my $file = shift;
    system("./change-to-dark.pl $file");
}

my $root_dir = shift @ARGV;
if (-d -r -x $root_dir and !(-l $root_dir)) {
    $root_dir =~ s{\/\z}{};
    &process_dir($root_dir);
} else {
    die "Bad root dir given: $root_dir";
}
