#!/usr/bin/perl
use strict;

# Counts how many icons change-dir-to-dark.pl and compare-light-dark.pl will process.

my $counted_icons = 0;

# Traverses one directory and counts all icons in it.
# Calls itself recursively for all directorys in that directory.
# Avoids symlinks (This is very important, to avoid that icons are counted twice!)
# Arg 1: path
sub process_dir
{
    my $dir = shift;
    for my $file (glob $dir . "/*") {
        if (-l $file) {
            next;
        } elsif (-d -r -x $file) {
            &process_dir($file);
        } elsif (-f -r $file) {
            ++$counted_icons;
        } else {
            die "Can not work with path $file";
        }
    }
}

my $root_dir = shift @ARGV;
if (-d -r -x $root_dir and !(-l $root_dir)) {
    $root_dir =~ s{\/\z}{};
    &process_dir($root_dir);
} else {
    die "Bad root dir given: $root_dir";
}

print "$counted_icons\n";
